/*
 * Copyright 2022 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

/***********************************************************************************/
/* This file is automatically generated using bindtool and can be manually edited  */
/* The following lines can be configured to regenerate this file during cmake      */
/* If manual edits are made, the following tags should be modified accordingly.    */
/* BINDTOOL_GEN_AUTOMATIC(0)                                                       */
/* BINDTOOL_USE_PYGCCXML(0)                                                        */
/* BINDTOOL_HEADER_FILE(spreading.h)                                               */
/* BINDTOOL_HEADER_FILE_HASH(0)                                                    */
/***********************************************************************************/

#include <pybind11/complex.h>
#include <pybind11/pybind11.h>
#include <pybind11/stl.h>

namespace py = pybind11;

#include <gnuradio/sidloc/spreading.h>
// pydoc.h is automatically generated in the build directory
#include <spreading_pydoc.h>


template <typename T>
void bind_spreading_template(py::module& m, const char* classname)
{
    using spreading = ::gr::sidloc::spreading<T>;
    py::class_<spreading,
               gr::tagged_stream_block,
               gr::block,
               gr::basic_block,
               std::shared_ptr<spreading>>(m, classname)
        .def(py::init(&spreading::make),
             py::arg("c"),
             py::arg("repetitions"),
             py::arg("scale"),
             py::arg("channel_interleaving"),
             py::arg("length_tag_key"),
             py::arg("period_tag_key"));
}

void bind_spreading_uint8_t(py::module& m)
{
    using spreading = ::gr::sidloc::spreading<uint8_t>;
    py::class_<spreading,
               gr::tagged_stream_block,
               gr::block,
               gr::basic_block,
               std::shared_ptr<spreading>>(m, "spreading_b")
        .def(py::init(&spreading::make),
             py::arg("c"),
             py::arg("repetitions"),
             py::arg("channel_interleaving"),
             py::arg("length_tag_key"),
             py::arg("period_tag_key"));
}

void bind_spreading(py::module& m)
{
    bind_spreading_template<float>(m, "spreading_f");
    bind_spreading_template<gr_complex>(m, "spreading_c");
    bind_spreading_uint8_t(m);
}
